unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ImgList, StdCtrls, Buttons, Gauges;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    BoxGame: TPaintBox;
    ListIcon: TImageList;
    ListIcon2: TImageList;
    Panel2: TPanel;
    Panel3: TPanel;
    Image1: TImage;
    LblKind1: TLabel;
    LblKind2: TLabel;
    LblKind3: TLabel;
    LblKind4: TLabel;
    LblKind5: TLabel;
    LblKind6: TLabel;
    LblKind7: TLabel;
    Panel4: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel5: TPanel;
    LblNext: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    SpeedButton1: TSpeedButton;
    Label9: TLabel;
    LblLevel: TLabel;
    Label11: TLabel;
    LblHint: TLabel;
    SpeedButton2: TSpeedButton;
    GaugeTimer: TGauge;
    procedure BoxGamePaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BoxGameMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    FBitmap: TBitmap;
    procedure DrawTextBitmapCenter(const AText: String);
  public
    { Public 錾 }                    
  end;

var
  MainForm: TMainForm;

implementation

uses
    SquareGrid, VertialField, Info;

{$R *.dfm}

//////
//-----------------------------------------------------------------------------
//  Sɕ`
procedure TMainForm.DrawTextBitmapCenter(const AText: String);

    procedure DrawTextCenter(AHDC: HDC; ARect: TRect; AText: String);
    begin
        DrawText(AHDC, PChar(AText), -1, ARect, DT_SINGLELINE or DT_CENTER or DT_VCENTER);
    end;

var
    LRect: TRect;
begin
    LRect := BoxGame.ClientRect;
    FBitmap.Canvas.Brush.Style := bsClear;

    FBitmap.Canvas.Font.Color := clWhite;
    OffsetRect(LRect, -2, -2);
    DrawTextCenter(FBitmap.Canvas.Handle, LRect, AText);
    OffsetRect(LRect, +4,  0);
    DrawTextCenter(FBitmap.Canvas.Handle, LRect, AText);
    OffsetRect(LRect,  0, +4);
    DrawTextCenter(FBitmap.Canvas.Handle, LRect, AText);
    OffsetRect(LRect, -4,  0);
    DrawTextCenter(FBitmap.Canvas.Handle, LRect, AText);
    FBitmap.Canvas.Font.Color := clBlack;
    OffsetRect(LRect, +2, -2);
    DrawTextCenter(FBitmap.Canvas.Handle, LRect, AText);

    FBitmap.Canvas.Brush.Style := bsSolid;
end;

//-----------------------------------------------------------------------------
procedure TMainForm.BoxGamePaint(Sender: TObject);
var
    i: Integer;
    j: Integer;
    LRect: TRect;
    LText: String;
begin
    FBitmap.Canvas.Brush.Color := clWhite;
    FBitmap.Canvas.FillRect(BoxGame.ClientRect);
    Square.DrawGrid(FBitmap.Canvas.Handle, 0, 0);

    for i := 0 to Square.ColCount - 1 do
    begin
        for j := 0 to Square.RowCount - 1 do
        begin
            LRect := Square.Cell(i, j);

            //  IZ͘g
            if (i = GameThread.Select.Y) and (j = GameThread.Select.X) then
            begin
                FBitmap.Canvas.Pen.Color := clBlack;
                FBitmap.Canvas.Brush.Color := clMaroon;
                FBitmap.Canvas.Rectangle(LRect);
            end;

            //  Z̓eC[WXgoĕ`

            //  ʏ
            if (GameThread.Status[j][i] = STATUS_NONE) then
            begin
                ListIcon.Draw(FBitmap.Canvas, LRect.Left, LRect.Top,
                                GameThread.Field[j][i]);
            end
            //  钼Ôт
            else
            if (GameThread.Status[j][i] in [STATUS_DELETE, STATUS_NOMOVE]) then
            begin
                ListIcon.Draw(FBitmap.Canvas, LRect.Left, LRect.Top,
                                GameThread.Field[j][i] + FIELD_SIZE);
            end
            //  
            else
            begin
                ListIcon2.Draw(FBitmap.Canvas, LRect.Left, LRect.Top, 0);
            end
        end;
    end;

    //  \
    if (GameThread.Mode = mNoMove) then
    begin
        LText := '!!! NO MOVE !!!';
        DrawTextBitmapCenter(LText);
    end
    else
    if (GameThread.ChainCounter > 0) then
    begin
        LText := Format('CHAIN BONUS X %d', [GameThread.ChainCounter + 1]);
        DrawTextBitmapCenter(LText);
    end
    else
    if (GameThread.Suspended) then
    begin
        LText := 'CLICK TO START';
        DrawTextBitmapCenter(LText);
    end;

    //  x
    LblNext.Caption := IntToStr(GameThread.Threshold);
    LblLevel.Caption := IntToStr(GameThread.Level);

    //  ^C}[
    GaugeTimer.MaxValue := GameThread.LevelTimer;
    GaugeTimer.Progress := GameThread.Timer;

    //  ޕʃJE^XV
    LblKind1.Caption := IntToStr(GameThread.KindCounter[1]);
    LblKind2.Caption := IntToStr(GameThread.KindCounter[2]);
    LblKind3.Caption := IntToStr(GameThread.KindCounter[3]);
    LblKind4.Caption := IntToStr(GameThread.KindCounter[4]);
    LblKind5.Caption := IntToStr(GameThread.KindCounter[5]);
    LblKind6.Caption := IntToStr(GameThread.KindCounter[6]);
    LblKind7.Caption := IntToStr(GameThread.KindCounter[7]);

    BitBlt(BoxGame.Canvas.Handle, 0, 0, BoxGame.Width, BoxGame.Height,
            FBitmap.Canvas.Handle, 0, 0, SRCCOPY);
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  h~
    FBitmap := TBitmap.Create();
    FBitmap.Width := Screen.Width;
    FBitmap.Height := Screen.Height;
    FBitmap.Canvas.Font.Assign(Self.Font);
    FBitmap.Canvas.Font.Size := 18;
    BoxGame.ControlStyle := BoxGame.ControlStyle + [csOpaque];

    //  Q[tB[hݒ
    Square.LineSize := 3;
    Square.LineColor := clWhite;
    Square.CellSize := ListIcon.Width;
    BoxGame.Width := Square.Width;
    BoxGame.Height := Square.Height;

    //  Q[Xbh쐬
    GameThread := TGameThread.Create();
end;

//-----------------------------------------------------------------------------
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    GameThread.Terminate();
    GameThread.Free();
    FBitmap.Free();
end;

//-----------------------------------------------------------------------------
procedure TMainForm.BoxGameMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
    LPoint: TPoint;
    LDirection: TDirection;
begin
    //  f
    if (GameThread.Suspended) then
    begin
        GameThread.Resume();
    end
    //  Q[
    else
    begin
        if (Button = mbLeft) then
        begin
            LPoint := Square.MouseToCell(X, Y);
            Caption := Format('X = %d / Y = %d', [LPoint.X, LPoint.Y]);
            GameThread.SetPoint(Point(LPoint.Y, LPoint.X));
        end
        else
        if (Button = mbRight) then
        begin
            GameThread.GetHint(LPoint, LDirection);
            LblHint.Caption := Format('MOVE (%d,%d) %s',
                                [LPoint.X + 1, LPoint.Y + 1, DIR_TEXT[LDirection]]);
        end;
    end;
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
    BoxGame.Repaint();
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
    OpenInfoForm();
end;

end.
